package com.torn.tetoru.parts;

import static com.torn.tetoru.parts.Mino.R_LEFT;
import static com.torn.tetoru.parts.Mino.R_RIGHT;


public class RotateRule {

	private static final int MODE_NORMAL = 0;
	private static final int MODE_TGM = 1;
	private static int mode = MODE_NORMAL;

	/**
	 * ]@ɏ]āAS̈ړ擾B
	 * ڂSRS(X[p[[e[VVXe)ŌB
	 * @param i (range from 1 to 5)
	 * @param type ~m
	 * @param turn ]Ỏ]
	 * @param dr ]̕
	 * @return
	 */
	public static Point moveDirection(int i, int type, int turn, int dr) {
		Point p;

		/* I~m */
		if (Block.I == type) {
			if (MODE_TGM == mode) {
				p = moveDirI_TGM(i, turn, dr);
			} else {
				p = moveDirI(i, turn, dr);
			}
		} else {
			p = moveDirOther(i, type, turn, dr);
		}
		return p;
	}
	
	
	
	/* ]@ɂĒS̈ړ */
	private static Point moveDirOther(int i, int type, int turn, int dr) {
		Point p = new Point(0, 0);
//					 2	 		3	 4	 	5
//		
//		E]	 {]	 1	 11	 2	 12
//		]	 {]	 E1	 E11	 2	 E12
//		E90x]
//		E]	 {]	 E1	 E11	 2	 E12
//		]	 {]	 E1	 E11	 2	 E12
//		180x]
//		E]	 {]	 E1	 E11	 2	 E12
//		]	 {]	 1	 11	 2	 12
//		90x]
//		E]	 {]	 1	 11	 2	 12
//		]	 {]	 1	 11	 2	 12
		switch(i) {
		// 
		case 1:
			break;


		// Q
		case 2:
			switch (turn) {
			case 0:
				if (dr == R_RIGHT) {
					p.x = -1;
				} else if (dr == R_LEFT) {
					p.x = 1;
				}
				break;
			case 1:
				if (dr == R_RIGHT) {
					p.x = 1;
				} else if (dr == R_LEFT) {
					p.x = 1;
				}
				break;
			case 2:
				if (dr == R_RIGHT) {
					p.x = 1;
				} else if (dr == R_LEFT) {
					p.x = -1;
				}
				break;
			case 3:
				if (dr == R_RIGHT) {
					p.x = -1;
				} else if (dr == R_LEFT) {
					p.x = -1;
				}
				break;
			}
			break;
		// R
		case 3:
			switch (turn) {
			case 0:
				if (type == Block.T)
					return p;	// pX
				if (dr == R_RIGHT) {
					p.x = -1;
					p.y = -1;
				} else if (dr == R_LEFT) {
					p.x = 1;
					p.y = -1;
				}
				break;
			case 1:
				if (dr == R_RIGHT) {
					p.x = 1;
					p.y = 1;
				} else if (dr == R_LEFT) {
					p.x = 1;
					p.y = 1;
				}
				break;
			case 2:
				if (type == Block.T)
					return p;	// pX
				if (dr == R_RIGHT) {
					p.x = 1;
					p.y = -1;
				} else if (dr == R_LEFT) {
					p.x = -1;
					p.y = -1;
				}
				break;
			case 3:
				if (dr == R_RIGHT) {
					p.x = -1;
					p.y = 1;
				} else if (dr == R_LEFT) {
					p.x = -1;
					p.y = 1;
				}
				break;
			}
			break;
		// S
		case 4:
			switch (turn) {
			case 0:
				if (dr == R_RIGHT) {
					p.y = 2;
				} else if (dr == R_LEFT) {
					p.y = 2;
				}
				break;
			case 1:
				if (dr == R_RIGHT) {
					p.y = -2;
				} else if (dr == R_LEFT) {
					p.y = -2;
				}
				break;
			case 2:
				if (dr == R_RIGHT) {
					p.y = 2;
				} else if (dr == R_LEFT) {
					p.y = 2;
				}
				break;
			case 3:
				if (dr == R_RIGHT) {
					p.y = -2;
				} else if (dr == R_LEFT) {
					p.y = -2;
				}
				break;
			}
			break;
		// T
		case 5:
			switch (turn) {
			case 0:
				if (dr == R_RIGHT) {
					p.x = -1;
					p.y = 2;
				} else if (dr == R_LEFT) {
					p.x = 1;
					p.y = 2;
				}
				break;
			case 1:
				if (dr == R_RIGHT) {
					p.x = 1;
					p.y = -2;
				} else if (dr == R_LEFT) {
					p.x = 1;
					p.y = -2;
				}
				break;
			case 2:
				if (dr == R_RIGHT) {
					p.x = 1;
					p.y = 2;
				} else if (dr == R_LEFT) {
					p.x = -1;
					p.y = 2;
				}
				break;
			case 3:
				if (dr == R_RIGHT) {
					p.x = -1;
					p.y = -2;
				} else if (dr == R_LEFT) {
					p.x = -1;
					p.y = -2;
				}
				break;
			}
			break;
		default:
			break;
		}
		
		return p;
	}
	
	private static Point moveDirI(int i, int turn, int dir) {
//		
//		E]	 {]	 2	 E1	 21	 E12
//		]	 {]	 1	 E2	 12	 E21
//		E90x]
//		E]	 {]	 1	 E2	 12	 E21
//		]	 {]	 E2	 1	 E21	 12
//		180x]
//		E]	 {]	 E1	 2	 E12	 21
//		]	 {]	 E2	 1	 E21	 12
//		90x]
//		E]	 {]	 E1	 2	 E12	 21
//		]	 {]	 2	 E1	 21	 E12

		Point p = new Point(0, 0);

		switch(i) {
		// 
		case 1:
			break;

		// Q
		case 2:
			switch (turn) {
			case 0:
				if (dir == R_RIGHT) {
					p.x = -2;
				} else if (dir == R_LEFT) {
					p.x = -1;
				}
				break;
			case 1:
				if (dir == R_RIGHT) {
					p.x = -1;
				} else if (dir == R_LEFT) {
					p.x = 2;
				}
				break;
			case 2:
				if (dir == R_RIGHT) {
					p.x = 1;
				} else if (dir == R_LEFT) {
					p.x = 2;
				}
				break;
			case 3:
				if (dir == R_RIGHT) {
					p.x = 1;
				} else if (dir == R_LEFT) {
					p.x = -2;
				}
				break;
			}
			break;
		// R
		case 3:
			switch (turn) {
			case 0:
				if (dir == R_RIGHT) {
					p.x = 1;
				} else if (dir == R_LEFT) {
					p.x = 2;
				}
				break;
			case 1:
				if (dir == R_RIGHT) {
					p.x = 2;
				} else if (dir == R_LEFT) {
					p.x = -1;
				}
				break;
			case 2:
				if (dir == R_RIGHT) {
					p.x = -2;
				} else if (dir == R_LEFT) {
					p.x = -1;
				}
				break;
			case 3:
				if (dir == R_RIGHT) {
					p.x = -2;
				} else if (dir == R_LEFT) {
					p.x = 1;
				}
				break;
			}
			break;
		// S
		case 4:
			switch (turn) {
			case 0:
				if (dir == R_RIGHT) {
					p.x = -2;
					p.y = 1;
				} else if (dir == R_LEFT) {
					p.x = -1;
					p.y = -2;
				}
				break;
			case 1:
				if (dir == R_RIGHT) {
					p.x = -1;
					p.y = -2;
				} else if (dir == R_LEFT) {
					p.x = -2;
					p.y = -1;
				}
				break;
			case 2:
				if (dir == R_RIGHT) {
					p.x = 1;
					p.y = 2;
				} else if (dir == R_LEFT) {
					p.x = 2;
					p.y = -1;
				}
				break;
			case 3:
				if (dir == R_RIGHT) {
					p.x = 1;
					p.y = 2;
				} else if (dir == R_LEFT) {
					p.x = -2;
					p.y = 1;
				}
				break;
			}
			break;
		// T
		case 5:
			switch (turn) {
			case 0:
				if (dir == R_RIGHT) {
					p.x = 1;
					p.y = -2;
				} else if (dir == R_LEFT) {
					p.x = 2;
					p.y = 1;
				}
				break;
			case 1:
				if (dir == R_RIGHT) {
					p.x = 2;
					p.y = 1;
				} else if (dir == R_LEFT) {
					p.x = -1;
					p.y = 2;
				}
				break;
			case 2:
				if (dir == R_RIGHT) {
					p.x = -2;
					p.y = -1;
				} else if (dir == R_LEFT) {
					p.x = -1;
					p.y = 2;
				}
				break;
			case 3:
				if (dir == R_RIGHT) {
					p.x = -2;
					p.y = -1;
				} else if (dir == R_LEFT) {
					p.x = 1;
					p.y = -2;
				}
				break;
			}
			break;
		default:
			break;
		}
		
		return p;
	}
	
	private static Point moveDirI_TGM(int i, int turn, int dir) {
//		eg~m̏	 ]	 	 	 O	 l	 ܌
//		
//		E]	 {]	 2	 E1	 21	 E12
//		]	 {]	 1	 E2	 12	 E21
//		E90x]
//		E]	 {]	 1	 E2	 12	 E21
//		]	 {]	 E2	 1	 E21	 12
//		180x]
//		E]	 {]	 E1	 2	 E12	 21
//		]	 {]	 E2	 1	 E21	 12
//		90x]
//		E]	 {]	 E1	 2	 E12	 21
//		]	 {]	 2	 E1	 21	 E12

		Point p = new Point(0, 0);

		switch(i) {
		// 
		case 1:
			break;

		// Q
		case 2:
			switch (turn) {
			case 0:
				if (dir == R_RIGHT) {
					p.x = -2;
				} else if (dir == R_LEFT) {
					p.x = 1;
				}
				break;
			case 1:
				if (dir == R_RIGHT) {
					p.x = -1;
				} else if (dir == R_LEFT) {
					p.x = 2;
				}
				break;
			case 2:
				if (dir == R_RIGHT) {
					p.x = -2;
				} else if (dir == R_LEFT) {
					p.x = 2;
				}
				break;
			case 3:
				if (dir == R_RIGHT) {
					p.x = -2;
				} else if (dir == R_LEFT) {
					p.x = 1;
				}
				break;
			}
			break;
		// R
		case 3:
			switch (turn) {
			case 0:
				if (dir == R_RIGHT) {
					p.x = 1;
				} else if (dir == R_LEFT) {
					p.x = -1;
				}
				break;
			case 1:
				if (dir == R_RIGHT) {
					p.x = 2;
				} else if (dir == R_LEFT) {
					p.x = -1;
				}
				break;
			case 2:
				if (dir == R_RIGHT) {
					p.x = 1;
				} else if (dir == R_LEFT) {
					p.x = -1;
				}
				break;
			case 3:
				if (dir == R_RIGHT) {
					p.x = 1;
				} else if (dir == R_LEFT) {
					p.x = -2;
				}
				break;
			}
			break;
		// S
		case 4:
			switch (turn) {
			case 0:
				if (dir == R_RIGHT) {
					p.x = 1;
					p.y = -1;
				} else if (dir == R_LEFT) {
					p.x = -1;
					p.y = -2;
				}
				break;
			case 1:
				if (dir == R_RIGHT) {
					p.x = -1;
					p.y = -2;
				} else if (dir == R_LEFT) {
					p.x = -2;
					p.y = -1;
				}
				break;
			case 2:
				if (dir == R_RIGHT) {
					p.x = -2;
					p.y = -1;
				} else if (dir == R_LEFT) {
					p.x = 2;
					p.y = -1;
				}
				break;
			case 3:
				if (dir == R_RIGHT) {
					p.x = -2;
					p.y = -1;
				} else if (dir == R_LEFT) {
					p.x = 1;
					p.y = -2;
				}
				break;
			}
			break;
		// T
		case 5:
			switch (turn) {
			case 0:
				if (dir == R_RIGHT) {
					p.x = -1;
					p.y = 1;
				} else if (dir == R_LEFT) {
					p.x = 2;
					p.y = 1;
				}
				break;
			case 1:
				if (dir == R_RIGHT) {
					p.x = 2;
					p.y = 1;
				} else if (dir == R_LEFT) {
					p.x = -1;
					p.y = 2;
				}
				break;
			case 2:
				if (dir == R_RIGHT) {
					p.x = 1;
					p.y = 1;
				} else if (dir == R_LEFT) {
					p.x = -1;
					p.y = 2;
				}
				break;
			case 3:
				if (dir == R_RIGHT) {
					p.x = 1;
					p.y = 2;
				} else if (dir == R_LEFT) {
					p.x = -2;
					p.y = 1;
				}
				break;
			}
			break;
		default:
			break;
		}
		
		return p;
	}

}